//
//    Copyright (C) 1993  Jeff McWhirter
//
#include	"CommonElt.h"

#include "ObjList.h"

bool gDoFromTlAttrMap = TRUE;
bool gDoFromHdAttrMap = TRUE;
bool gDoFromRelAttrMap = TRUE;

bool gDoDieHints = FALSE;
bool gDoCopyHints = FALSE;



ObjList * eAEventDieObjList=0;
ObjList * eAEventCopyObjList=0;
ObjList * eAEventMoveByObjList=0;
ObjList * eAEventReshapeObjList=0;
ObjList * eAEventScaleObjList=0;
ObjList * eAEventAddElementObjList=0;
ObjList * eAEventDrawObjList=0;
ObjList * eAEventSignalImageChangeObjList=0;
ObjList * eAEventDieHintObjList=0;
ObjList * eAEventCopyHintObjList=0;


ObjList * GetEventList(Events event){
if((event & eAEventDie)!=0) return eAEventDieObjList;
else if ((event & eAEventDieHint)!=0) return eAEventDieObjList;


else if ((event & eAEventCopy)!=0) return eAEventCopyObjList;
else if ((event & eAEventCopyHint)!=0) return eAEventCopyObjList;

else if ((event & eAEventMoveBy)!=0) return eAEventMoveByObjList;
else if ((event & eAEventMoveByHint)!=0) return eAEventMoveByObjList;

else if ((event & eAEventReshape)!=0) return eAEventReshapeObjList;

else if ((event & eAEventScale)!=0) return eAEventScaleObjList;
else if ((event & eAEventScaleHint)!=0) return eAEventScaleObjList;

else if ((event & eAEventAddElement)!=0) return eAEventAddElementObjList;
else if ((event & eAEventDraw)!=0) return eAEventDrawObjList;
else if ((event & eAEventSignalImageChange)!=0) return eAEventSignalImageChangeObjList;
else if ((event & eAEventDieHint)!=0) return eAEventDieHintObjList;
else if ((event & eAEventCopyHint)!=0) return eAEventCopyHintObjList;
return 0;
}


void  SetEventList(Events event, ObjList * s){
if ((event & eAEventDie)!=0)  eAEventDieObjList = s;
else if ((event & eAEventCopy)!=0)  eAEventCopyObjList = s;
else if ((event & eAEventMoveBy)!=0)  eAEventMoveByObjList = s;
else if ((event & eAEventReshape)!=0)  eAEventReshapeObjList = s;
else if ((event & eAEventScale)!=0)  eAEventScaleObjList = s;
else if ((event & eAEventAddElement)!=0)  eAEventAddElementObjList = s;
else if ((event & eAEventDraw)!=0)  eAEventDrawObjList = s;
else if ((event & eAEventSignalImageChange)!=0)  eAEventSignalImageChangeObjList = s;
else if((event & eAEventDieHint)!=0)  eAEventDieHintObjList = s;
else if((event & eAEventCopyHint)!=0) eAEventCopyHintObjList=s;
}




#ifdef USE_VISUAL
#include "PVGraphElement.h"
#endif

#ifdef USE_STRUCTURAL
#include "PSGraphElement.h"
#endif

void KillElement(Object*o){
	if(!o) return;
#ifdef USE_VISUAL
	if(o->IsKindOf(PVGraphElement))
		((PVGraphElement*)o)->Die();
	else 
#endif
#ifdef USE_STRUCTURAL
	if(o->IsKindOf(PSGraphElement)){
		((PSGraphElement*)o)->Die();
		KillSGraphElements();
	} else
#endif

	return;

#ifdef USE_VISUAL
	KillVGraphElements();
#endif
}






